



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>JAVA String类型和原型模式</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">JAVA String类型和原型模式</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-15 17:39:01 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>如上例所述，变量a，b和它们的值10，20都是存在栈里面，声明的所以String类型的引用也都是存在栈里。而字符串abc是存在字符串常量池中，new出来的String对象则是存在堆里。</p>
<pre class="prettyprint linenums"><code>String str="abc";<br />
System.out.print(str==str1);//true</code></pre>
<p>上面这行代码被执行的时候，JVM先到字符串池中查找，看是否已经存在值为&rdquo;abc&rdquo;的对象，如果存在，则不再创建新的对象，直接返回已存在对象的引用；如果不存在，则先创建这个对象，然后把它加入到字符串池中，再将它的引用返回。所以这句代码<strong>创建了一个对象</strong>。</p>
<pre class="prettyprint linenums"><code>String str1="abc";<br />
System.out.print(str==str2);//true  </code></pre>
<p>通过上面的解释这个就清楚了，在执行第二行代码时，&rdquo;abc&rdquo;字符串对象在常量池中已存在，所以直接返回池中已存在的那个字符串对象。</p>
<pre class="prettyprint linenums"><code>String str2="a"+"b"+"c";</code></pre>
<p>由于常量字符串是在编译的时候就也被确定的，又因&rdquo;a&rdquo;,&rdquo;b&rdquo;和&rdquo;c&rdquo;都是常量，因此变量str2的值在编译时就可以确定。这行代码编译后的与String str=&rdquo;abc&rdquo;;是一样的，所以这句代码也是<strong>只创建了一个对象</strong>，但是这与我们平时好像不太一样啊？<strong>一般使用&ldquo;+&rdquo;连接两个字符串都会产生另一个新的字符对象</strong>。下面我们看一下下面这行代码就明白了：</p>
<pre class="prettyprint linenums"><code>String str3="c";<br />
String str4="ab"+str3;<br />
System.out.print(str==str4);//false<br />
String str5="ab";<br />
System.out.print(str==str6);//false</code></pre>
<p>从上面例子我们就可以得出：<strong>使用&ldquo;+&rdquo;连接的两个字符串本身就是字面常量字符串时，如果池中存在这样连接后的字符串，则是不会重新创建对象，而是直接引用池中的字符串对象；如果&ldquo;+&rdquo;连接的两字符串中只要有一个不是字面常量串（即已经定义过的），会产生新的字符串对象（抛去特殊如final定义字符串不提）。</strong> <br /> 那我们来看一下有new创建字符串时会有什么不同：</p>
<pre class="prettyprint linenums"><code>String str7=new String("abc");  </code></pre>
<p>首先、这行代码究竟创建了几个String对象呢？<strong>答案是2个</strong>。由于new String(&ldquo;abc&rdquo;)相当于&rdquo;abc&rdquo;,一个就是创建出来的放在堆的原实例对象，而另一个就是放在常量池中的 &ldquo;aaa&rdquo; 对象，当然这里的str7本身只是一个引用，放在栈里，用来指向堆中创建出来的对象。</p>
<pre class="prettyprint linenums"><code>String str7=new String("abc");<br />
String str8=new String("abc");<br />
System.out.print(str7.equals(str8));//true<br />
System.out.print(str7==str8);//false<br />
System.out.print(str==str7);//false</code></pre>
<p>由于str7和str8是连个存在栈里的引用，他们分别创建了两个对象&rdquo;abc&rdquo;，虽然他们内容相同(str7.equals(str8)==true)，但是实际存在物理地址不同，所以str7==str8值为false，同理，str指向常量池中的&rdquo;abc&rdquo;，所以str==str7也是false。</p>
<p>关于常量池，是为了避免频繁的创建和销毁对象而影响系统性能，其实现了对象的共享。 <br /> 例如字符串常量池，在编译阶段就把所有的字符串文字放到一个常量池中。 <br /> （1）节省内存空间：常量池中所有相同的字符串常量被合并，只占用一个空间。 <br /> （2）节省运行时间：比较字符串时，==比equals()快。对于两个引用变量，只用==判断引用是否相等，也就可以判断实际值是否相等。</p>
<p>注意:常量池主要用于存放两大类常量：字面量(Literal)和符号引用量(Symbolic References)，字面量相当于Java语言层面常量的概念，如文本字符串，声明为final的常量值等，符号引用则属于编译原理方面的概念。 <br /> 所以当然常量池不只是表示字符串常量池，例如<strong>一些包装类都实现了常量池技术</strong>。</p>
<p>基本类型和基本类型的包装类。基本类型有：byte、short、char、int、long、boolean。基本类型的包装类分别是：Byte、Short、Character、Integer、Long、Boolean（注意区分大小写）。 <br /> 二者的区别是：<strong>基本类型体现在程序中是普通变量，基本类型的包装类是类，体现在程序中是引用变量。</strong>因此二者在内存中的存储位置不同：<strong>基本类型存储在栈中，而基本类型包装类存储在堆中</strong>。 <br /> 上边提到的这些包装类都实现了常量池技术，另外<strong>两种浮点数类型的包装类则没有实现</strong>。 <br /> 如下：</p>
<pre class="prettyprint linenums"><code>        Integer i1=10;<br />
        Integer i2=10;<br />
        Integer i3=new Integer(10);<br />
        Integer i4=new Integer(10);<br />
        System.out.print(i1==i2);//true<br />
        System.out.print(i2==i3);//false<br />
        System.out.print(i3==i4);//false<br />
        Double d1=1.0;<br />
        Double d2=1.0;<br />
        System.out.print(d1==d2);//false</code></pre>
<p>案例分析： <br />1）i1和i2均是引用类型，在栈中存储指针，因为Integer是包装类。由于Integer包装类实现了常量池技术，因此i1和i2的10均是从常量池中获取的，均指向同一个地址，因此i1=12。 <br />2）i3和i4均是引用类型，在栈中存储指针，因为Integer是包装类。但是由于他们各自都是new出来的，因此不再从常量池寻找数据，而是从堆中各自new一个对象，然后各自保存指向对象的指针，所以i3和i4不相等，因为他们所存指针不同，所指向对象不同。 <br />3）d1和d2均是引用类型，在栈中存储指针，因为Double是包装类。但Double包装类没有实现常量池技术，因此Doubled1=1.0;相当于Double d1=new Double(1.0);，是从堆new一个对象，d2同理。因此d1和d2存放的指针不同，指向的对象不同，所以不相等。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/3901x7m8.html">Javascript备忘复习笔记2</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2ee1lq.html">点击 Run 之后发生了什么？</a>
		</li>
						<li><a href="https://www.batexi.com/a/2q71myjq.html">19．创建如下三个类：（People类中的三个方法分别输出一些信息，ChinaPeople 和AmericanPeople类重写父类的三个方法）。</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1xkne9.html">最近用到的Linux常用命令总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wejoxq.html">大文件遍历shell脚本</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1ezj59.html">FastReport 动态修改连接字符串</a>
		</li>
						<li><a href="https://www.batexi.com/a/qydkz6xq.html">Oracle 提示密码过期问题：the password will expire</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkwdoj8.html">ASP&period;NET  操作配置文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jd0nx8.html">Log4J logger图片</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj04gy8.html">Markdown轻量级标记语言</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1kjom59.html">es6 箭头函数&lpar;arrow function&rpar; 学习笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj7y35q.html">maven 使用 log4j</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1z5gg9.html">ssh多台主机之间不用密码远程</a>
		</li>
						<li><a href="https://www.batexi.com/a/9604om39.html">【Android】为需要支持API 11之前的Activity添加Action Bar的一种解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll6gx1q.html">白鹭引擎 - 资源文件的加载 &lpar; RES&comma; loadConfig&comma; loadGroup &rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv26dyz9.html">centos6&period;5下oracle自动备份删除指定天数的文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/953mgrz8.html">Python做接口自动化测试框架</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ewd219.html">java IO流之文件切割两例（含Properties 用法）</a>
		</li>
						<li><a href="https://www.batexi.com/a/ql136we9.html">&period;net二纬码标签打印</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2kz3yvq.html">阿里巴巴前端面试分享-社招（p6）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qwj1e438.html">引入UEditor后其他列表项不显示</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rge3r78.html">如何解决Dynamics 365的错误：用户身份验证无效，MSIS0006</a>
			</li>
						<li><a href="https://www.batexi.com/a/qljgd119.html">CentOS 7安装指南</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojzp5eq.html">OPC协议解析-OPC客户端与服务器通讯解析</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzw7jw8.html">android常犯错误记录（二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv16mkjq.html">Linux &amp;amp&semi; Windows 环境下 Redis 安装与基本配置</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4zrvw39.html">SQL Server 迁移至MySQL 关键步骤的梳理总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1k06o49.html">Python第十一天    异常处理  glob模块和shlex模块    打开外部程序和subprocess模块  subprocess类  Pipe管道  operator模块   sorted函数    os模块   hashlib模块  platform模块  csv模块</a>
			</li>
						<li><a href="https://www.batexi.com/a/8ojze75q.html">电脑出现问题如何修复Windows 10</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zoddo3q.html">nmap比较详细的使用方法</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
